import * as Events from 'events'
import * as logger from './log'


export abstract class Instance extends Events.EventEmitter {

  protected options : any

  constructor(options : any) {
    super()
    this.options = options
  }


  logerror(msg: string) {
    logger.error(`${this.options.instanceId}: ${msg}`)
  }

  logwarn(msg: string) {
    logger.warn(`${this.options.instanceId}: ${msg}`)
  }

  loginfo(msg: string) {
    logger.info(`${this.options.instanceId}: ${msg}`)
  }

  abstract connectToDatabase() : void

  abstract connectToQueue() : void

  exec() : void {
    this.connectToDatabase()
    this.connectToQueue()
  }
}
